/*
	Copyright (c) 2004 PXI Project Team

	Permission is hereby granted, free of charge, to any person obtaining a copy of
	this software and associated documentation files (the "Software"), to deal in the
	Software without restriction, including without limitation the rights to use,
	copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
	Software, and to permit persons to whom the Software is furnished to do so,
	subject to the following conditions:

	The above copyright notice and this permission notice shall be included in all copies
	or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
	INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
	PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
	HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
	OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
	SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#ifndef _____PXIOBJECT_____
#define _____PXIOBJECT_____

#include <string>
#include <vector>
#include <map>
#include "memoryblock.h"
#include "PXITypes.h"
#include "PXIVariant.h"
using namespace std;

unsigned char propNameToID(string);
string propIDtoName(unsigned char);

class PXIObject
{
	public:

	int propCount(void);
	PXIVariant getProp(string);
	PXIVariant getProp(unsigned char);
	bool hasProp(string);
	bool hasProp(unsigned char);
	void removeProp(string);
	void removeProp(unsigned char);
	void setProp(string, PXIVariant);
	void setProp(unsigned char, PXIVariant);

	int partCount(void);
	PXIObject getPart(int);
	bool hasPart(int);
	void removePart(int);
	void setPart(int, PXIObject);

	string partIDtoName(int);
	int partIDtoNumber(int);
	int partNameToID(string);
	int partNameToNumber(string);
	int partNumberToID(int);
	string partNumberToName(int);

	int partIDofTypeToPartNumberOfType(int, int);
	int partNameOfTypeToPartID(int, string);
	int partNameOfTypeToPartNumber(int, string);
	int partNameOfTypeToPartNumberOfType(int, string);
	int partNumberOfTypeToPartID(int, int);
	string partNumberOfTypeToPartName(int, int);
	int partNumberOfTypeToPartNumber(int, int);

	int partPropCount(int);
	PXIVariant partGetProp(int, string);
	PXIVariant partGetProp(int, unsigned char);
	bool partHasProp(int, string);
	bool partHasProp(int, unsigned char);
	void partRemoveProp(int, string);
	void partRemoveProp(int, unsigned char);
	void partSetProp(int, string, PXIVariant);
	void partSetProp(int, unsigned char, PXIVariant);

	memoryblock getPropListString(void);
	void setPropListString(memoryblock);
	memoryblock getObjectString(void);
	void setObjectString(memoryblock);

	private:

	map<unsigned char,PXIVariant> propertyList;
	vector<PXIObject> partList;
};

#endif